using System.Collections;
using System.Collections.Generic;
using Unity.Android.Gradle.Manifest;
using UnityEngine;
using static AnimacjaDzikiego;

public class RuchBohatera : MonoBehaviour
{
    public CharacterController kontroler;
    public Transform kamera;
    private bool fGrunt;
    //przyspieszenie grawitacyjne
    public float g = -9.8f;

    //wspczynnik prdkoci
    const float constV = 2.5f;
    public float v= constV,
                 wysSkoku=2.0f;
    Vector3 wektorPredkosci = Vector3.zero;
    public float wygladzenie = 0.1f;
    float buforBiezacegoWygladzania;
    


    public void Skok()
    {
        if (fGrunt && Input.GetAxis("Jump") != 0)
        {
            //v=Pierwiastek(2gh)
            wektorPredkosci.y = Mathf.Sqrt(-2f * g * wysSkoku);
            GetComponent<AnimacjaDzikiego>().StanAnimacji 
                              = STAN_ANIMACJI.SKOK;
        }
    }

    void Spadaj()
    {
        wektorPredkosci.y += g * Time.deltaTime;
        if (fGrunt && wektorPredkosci.y < 0)
        {
            //nie spadaj szybciej ni 54m/s
            wektorPredkosci.y = -54f;
        }
        kontroler.Move(wektorPredkosci * Time.deltaTime);
    }
    void Ruch()
    {
        float poziom = Input.GetAxis("Horizontal");
        float pion = Input.GetAxis("Vertical");
        Vector3 kierunek = new Vector3(poziom, 0, pion).normalized;
        //czy ruch, powiedzmy wiecej ni 5 centymetrw
        if (kierunek.magnitude >= 0.05f)
        {
            //obrt postaci
            //zwrc kt w radianach z paszczyzny 2D- o X a Z
            //zamie radiany na stopnie
            float katPatrzenia = Mathf.Atan2(kierunek.x, kierunek.z)
                                 *Mathf.Rad2Deg+
                                 kamera.eulerAngles.y;
            //wygladzaj obrot,
            //predkosc wygladzania wyslij do bufora
            float kat = Mathf.SmoothDampAngle(
                      transform.eulerAngles.y,
                      katPatrzenia,
                      ref wygladzenie,
                      buforBiezacegoWygladzania
                      );
            transform.rotation = Quaternion.Euler(0, kat, 0);
            Vector3 kierunekRuchu = Quaternion.Euler(0, katPatrzenia, 0)
                                    *Vector3.forward;
            kontroler.Move(kierunekRuchu.normalized * v * Time.deltaTime);
            //jest ruch to domyslnie ustawiaj na spacer
            if (GetComponent<AnimacjaDzikiego>().StanAnimacji == STAN_ANIMACJI.CZEKAJ)
              {
                GetComponent<AnimacjaDzikiego>().StanAnimacji = STAN_ANIMACJI.SPACER;
                GetComponent<AnimacjaDzikiego>().wspolczynnikZmianyPredkosci = constV;
              }
            GetComponent<AnimacjaDzikiego>().PrzelaczAnimacje(constV);
            v = GetComponent<AnimacjaDzikiego>().wspolczynnikZmianyPredkosci;
        }
        else
        {
            //pozostae animacje przeacz
            //w skrypcie AnimacjaDzikiego
            GetComponent<AnimacjaDzikiego>().StanAnimacji = STAN_ANIMACJI.CZEKAJ;
        }
    }
    
    // Start is called before the first frame update
    void Start()
    {
        //blokuj kursor na srodku ekranu
        Cursor.lockState = CursorLockMode.Locked;
        //ukryj kursor
        //standardowo klawisz Esc przywrci widok kursora
        Cursor.visible = false;
    }

    // Update is called once per frame
    void Update()
    {
        //sprawdzaj czy jestes nad dowolnym podlozem
        fGrunt = kontroler.isGrounded;
        Ruch();
        Skok();
        Spadaj();
    }
    
}
